diff -r -u squid-2.6.STABLE13/src/auth/digest/auth_digest.c new-STABLE13/src/auth/digest/auth_digest.c
--- squid-2.6.STABLE13/src/auth/digest/auth_digest.c	Mon Jul 31 08:27:04 2006
+++ new-STABLE13/src/auth/digest/auth_digest.c	Sun May 13 00:59:37 2007
@@ -727,16 +727,17 @@
 		return;
 	    } else {
 		const char *useragent = httpHeaderGetStr(&request->header, HDR_USER_AGENT);
-		static struct in_addr last_broken_addr;
+		static struct sockaddr_storage last_broken_addr;
 		static int seen_broken_client = 0;
 
 		if (!seen_broken_client) {
-		    last_broken_addr = no_addr;
+		    memset(&last_broken_addr, '\0', sizeof(last_broken_addr)); 
 		    seen_broken_client = 1;
 		}
 		if (memcmp(&last_broken_addr, &request->client_addr, sizeof(last_broken_addr)) != 0) {
-		    debug(29, 1) ("\nDigest POST bug detected from %s using '%s'. Please upgrade browser. See Bug #630 for details.\n", inet_ntoa(request->client_addr), useragent ? useragent : "-");
-		    last_broken_addr = request->client_addr;
+		    debug(29, 1) ("\nDigest POST bug detected from %s using '%s'. Please upgrade browser. See Bug #630 for details.\n", sockaddr_ntoa(&request->client_addr), useragent ? useragent : "-");
+		    xmemcpy(&last_broken_addr, &request->client_addr, 
+			SOCKLEN(&request->client_addr));
 		}
 	    }
 	} else {
diff -r -u squid-2.6.STABLE13/src/authenticate.c new-STABLE13/src/authenticate.c
--- squid-2.6.STABLE13/src/authenticate.c	Tue Jan  2 07:44:58 2007
+++ new-STABLE13/src/authenticate.c	Sun May 13 00:59:36 2007
@@ -43,7 +43,7 @@
 CBDATA_TYPE(auth_user_ip_t);
 
 static void authenticateDecodeAuth(const char *proxy_auth, auth_user_request_t * auth_user_request);
-static auth_acl_t authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr);
+static auth_acl_t authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr);
 
 /*
  *
@@ -259,11 +259,10 @@
 }
 
 static void
-authenticateAuthUserRequestSetIp(auth_user_request_t * auth_user_request, struct in_addr ipaddr)
+authenticateAuthUserRequestSetIp(auth_user_request_t * auth_user_request, struct sockaddr *ipaddr)
 {
     auth_user_ip_t *ipdata, *next;
     auth_user_t *auth_user;
-    char *ip1;
     int found = 0;
     CBDATA_INIT_TYPE(auth_user_ip_t);
     if (!auth_user_request->auth_user)
@@ -278,7 +277,7 @@
     while ((ipdata = next) != NULL) {
 	next = (auth_user_ip_t *) ipdata->node.next;
 	/* walk the ip list */
-	if (ipdata->ipaddr.s_addr == ipaddr.s_addr) {
+	if (!memcmp(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr))) {
 	    /* This ip has already been seen. */
 	    found = 1;
 	    /* update IP ttl */
@@ -295,17 +294,15 @@
     /* This ip is not in the seen list */
     ipdata = cbdataAlloc(auth_user_ip_t);
     ipdata->ip_expiretime = squid_curtime;
-    ipdata->ipaddr = ipaddr;
+    xmemcpy(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr));
     dlinkAddTail(ipdata, &ipdata->node, &auth_user->ip_list);
     auth_user->ipcount++;
 
-    ip1 = xstrdup(inet_ntoa(ipaddr));
-    debug(29, 2) ("authenticateAuthUserRequestSetIp: user '%s' has been seen at a new IP address (%s)\n", authenticateUserUsername(auth_user), ip1);
-    safe_free(ip1);
+    debug(29, 2) ("authenticateAuthUserRequestSetIp: user '%s' has been seen at a new IP address (%s)\n", authenticateUserUsername(auth_user), sockaddr_ntoa(ipaddr));
 }
 
 void
-authenticateAuthUserRequestRemoveIp(auth_user_request_t * auth_user_request, struct in_addr ipaddr)
+authenticateAuthUserRequestRemoveIp(auth_user_request_t * auth_user_request, struct sockaddr *ipaddr)
 {
     auth_user_ip_t *ipdata;
     auth_user_t *auth_user;
@@ -315,7 +312,7 @@
     ipdata = (auth_user_ip_t *) auth_user->ip_list.head;
     while (ipdata) {
 	/* walk the ip list */
-	if (ipdata->ipaddr.s_addr == ipaddr.s_addr) {
+	if (!memcmp(&ipdata->ipaddr, ipaddr, SOCKLEN(ipaddr))) {
 	    authenticateAuthUserRemoveIpEntry(auth_user, ipdata);
 	    return;
 	}
@@ -434,7 +431,7 @@
  * the authenticateStart routine for rv==AUTH_ACL_HELPER
  */
 auth_acl_t
-authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr)
+authenticateAuthenticate(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr)
 {
     const char *proxy_auth;
     assert(headertype != 0);
@@ -500,8 +497,8 @@
 	if (proxy_auth && !request->auth_user_request && conn && conn->auth_user_request) {
 	    int id = authenticateAuthSchemeId(proxy_auth) + 1;
 	    if (!conn->auth_user_request->auth_user || conn->auth_user_request->auth_user->auth_module != id) {
-		debug(29, 1) ("authenticateAuthenticate: Unexpected change of authentication scheme from '%s' to '%s' (client %s)\n",
-		    authscheme_list[conn->auth_user_request->auth_user->auth_module - 1].typestr, proxy_auth, inet_ntoa(src_addr));
+		debug(29, 1) ("authenticateAuthenticate: Unexpected change of authentication scheme from '%s' to '%s'", /* (client %s)\n",*/
+		    authscheme_list[conn->auth_user_request->auth_user->auth_module - 1].typestr, proxy_auth/*, inet_ntoa(src_addr)*/); /* XXX husni */
 		authenticateAuthUserRequestUnlock(conn->auth_user_request);
 		conn->auth_user_request = NULL;
 		conn->auth_type = AUTH_UNKNOWN;
@@ -602,7 +599,7 @@
 }
 
 auth_acl_t
-authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct in_addr src_addr)
+authenticateTryToAuthenticateAndSetAuthUser(auth_user_request_t ** auth_user_request, http_hdr_type headertype, request_t * request, ConnStateData * conn, struct sockaddr *src_addr)
 {
     /* If we have already been called, return the cached value */
     auth_user_request_t *t = authTryGetUser(auth_user_request, conn, request);
diff -r -u squid-2.6.STABLE13/src/cache_cf.c new-STABLE13/src/cache_cf.c
--- squid-2.6.STABLE13/src/cache_cf.c	Tue Feb 27 07:45:24 2007
+++ new-STABLE13/src/cache_cf.c	Sun May 13 00:59:36 2007
@@ -76,6 +76,7 @@
 };
 
 
+static void cbdataFree_http_port(void *data);
 static void update_maxobjsize(void);
 static void configDoConfigure(void);
 static void parse_refreshpattern(refresh_t **);
@@ -103,11 +104,11 @@
 static void dump_denyinfo(StoreEntry * entry, const char *name, acl_deny_info_list * var);
 static void free_denyinfo(acl_deny_info_list ** var);
 #if USE_WCCPv2
-static void parse_sockaddr_in_list(sockaddr_in_list **);
-static void dump_sockaddr_in_list(StoreEntry *, const char *, const sockaddr_in_list *);
-static void free_sockaddr_in_list(sockaddr_in_list **);
+static void parse_sockaddr_storage_list(sockaddr_storage_list **);
+static void dump_sockaddr_storage_list(StoreEntry *, const char *, const sockaddr_storage_list *);
+static void free_sockaddr_storage_list(sockaddr_storage_list **);
 #if UNUSED_CODE
-static int check_null_sockaddr_in_list(const sockaddr_in_list *);
+static int check_null_sockaddr_storage_list(const sockaddr_storage_list *);
 #endif
 #endif
 static void parse_http_port_list(http_port_list **);
@@ -757,31 +758,44 @@
 }
 
 static void
-dump_address(StoreEntry * entry, const char *name, struct in_addr addr)
+dump_address(StoreEntry * entry, const char *name, struct sockaddr *addr)
 {
-    storeAppendPrintf(entry, "%s %s\n", name, inet_ntoa(addr));
+    storeAppendPrintf(entry, "%s %s\n", name, sockaddr_ntoa(addr));
 }
 
 static void
-parse_address(struct in_addr *addr)
+parse_address(struct sockaddr *addr)
 {
     const struct hostent *hp;
+    struct addrinfo hints, *res, *res0;
+    int error;
     char *token = strtok(NULL, w_space);
 
     if (token == NULL)
 	self_destruct();
     if (safe_inet_addr(token, addr) == 1)
 	(void) 0;
-    else if ((hp = gethostbyname(token)))	/* dont use ipcache */
-	*addr = inaddrFromHostent(hp);
-    else
-	self_destruct();
+    else {
+	memset(&hints, 0, sizeof(hints));
+	hints.ai_family = PF_UNSPEC;
+	hints.ai_flags = AI_PASSIVE;
+	error = getaddrinfo(token, NULL, &hints, &res);
+	if (error)
+	    self_destruct();
+	for (res = res0; res; res = res->ai_next) {
+	    if ((res->ai_family == AF_INET) || (res->ai_family == AF_INET6)) {
+		xmemcpy(addr, res->ai_addr, SOCKLEN(res->ai_addr));
+		break;
+	    }
+	}
+	freeaddrinfo(res0);
+    }
 }
 
 static void
-free_address(struct in_addr *addr)
+free_address(struct sockaddr *addr)
 {
-    memset(addr, '\0', sizeof(struct in_addr));
+    memset(addr, '\0', SOCKLEN(addr));
 }
 
 CBDATA_TYPE(acl_address);
@@ -791,10 +805,8 @@
 {
     acl_address *l;
     for (l = head; l; l = l->next) {
-	if (l->addr.s_addr != INADDR_ANY)
-	    storeAppendPrintf(entry, "%s %s", name, inet_ntoa(l->addr));
-	else
-	    storeAppendPrintf(entry, "%s autoselect", name);
+	storeAppendPrintf(entry, "%s %s", name, sockaddr_ntoa(&l->addr));
+/*	storeAppendPrintf(entry, "%s autoselect", name);	*/
 	dump_acl_list(entry, l->acl_list);
 	storeAppendPrintf(entry, "\n");
     }
@@ -2613,19 +2625,20 @@
 
 #if USE_WCCPv2
 static void
-parse_sockaddr_in_list(sockaddr_in_list ** head)
+parse_sockaddr_storage_list(sockaddr_storage_list ** head)
 {
     char *token;
     char *t;
     char *host;
     char *tmp;
-    const struct hostent *hp;
+    struct addrinfo hints, *res, *res0;
     unsigned short port = 0;
-    sockaddr_in_list *s;
+    sockaddr_storage_list *s;
+    int error;
     while ((token = strtok(NULL, w_space))) {
 	host = NULL;
 	port = 0;
-	if ((t = strchr(token, ':'))) {
+	if ((t = strrchr(token, ':'))) {
 	    /* host:port */
 	    host = token;
 	    *t = '\0';
@@ -2639,15 +2652,27 @@
 	    port = 0;
 	}
 	s = xcalloc(1, sizeof(*s));
-	s->s.sin_port = htons(port);
-	if (NULL == host)
-	    s->s.sin_addr = any_addr;
-	else if (1 == safe_inet_addr(host, &s->s.sin_addr))
+	if (safe_inet_addr(token, &s->s) == 1)
 	    (void) 0;
-	else if ((hp = gethostbyname(host)))	/* dont use ipcache */
-	    s->s.sin_addr = inaddrFromHostent(hp);
+	else {
+	    memset(&hints, 0, sizeof(hints));
+	    hints.ai_family = PF_UNSPEC;
+	    hints.ai_flags = AI_PASSIVE;
+	    error = getaddrinfo(token, NULL, &hints, &res);
+	    if (error)
+		self_destruct();
+	    for (res = res0; res; res = res->ai_next) {
+		if ((res->ai_family == AF_INET) || (res->ai_family == AF_INET6)) {
+		    xmemcpy(&s->s, res->ai_addr, SOCKLEN(res->ai_addr));
+		    break;
+		}
+	    }
+	    freeaddrinfo(res0);
+	}
+	if (s->s.ss_family == AF_INET6)
+	    ((struct sockaddr_in6 *)&s->s)->sin6_port = htons(port);
 	else
-	    self_destruct();
+	    ((struct sockaddr_in *)&s->s)->sin_port = htons(port);
 	while (*head)
 	    head = &(*head)->next;
 	*head = s;
@@ -2655,21 +2680,23 @@
 }
 
 static void
-dump_sockaddr_in_list(StoreEntry * e, const char *n, const sockaddr_in_list * s)
+dump_sockaddr_storage_list(StoreEntry * e, const char *n, const sockaddr_storage_list * s)
 {
     while (s) {
 	storeAppendPrintf(e, "%s %s:%d\n",
 	    n,
-	    inet_ntoa(s->s.sin_addr),
-	    ntohs(s->s.sin_port));
+	    sockaddr_ntoa(&s->s),
+	    s->s.ss_family == AF_INET6 ?
+		ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
+		ntohs(((struct sockaddr_in *)&s->s)->sin_port)); 
 	s = s->next;
     }
 }
 
 static void
-free_sockaddr_in_list(sockaddr_in_list ** head)
+free_sockaddr_storage_list(sockaddr_storage_list ** head)
 {
-    sockaddr_in_list *s;
+    sockaddr_storage_list *s;
     while ((s = *head) != NULL) {
 	*head = s->next;
 	xfree(s);
@@ -2678,7 +2705,7 @@
 
 #if UNUSED_CODE
 static int
-check_null_sockaddr_in_list(const sockaddr_in_list * s)
+check_null_sockaddr_storage_list(const sockaddr_storage_list * s)
 {
     return NULL == s;
 }
@@ -2688,32 +2715,64 @@
 static void
 parse_http_port_specification(http_port_list * s, char *token)
 {
+    CBDATA_TYPE(http_port_list);
     char *host = NULL;
-    const struct hostent *hp;
+    char *portstr = NULL;
+    struct addrinfo hints, *res, *res0;
+    http_port_list *sn1, *sn2;
+    int error;
     unsigned short port = 0;
     char *t;
-    if ((t = strchr(token, ':'))) {
+    CBDATA_INIT_TYPE_FREECB(http_port_list, cbdataFree_http_port);
+    if ((t = strrchr(token, ':'))) {
 	/* host:port */
+	port = xatos(t + 1);
+	portstr = t + 1;
 	host = token;
 	*t = '\0';
-	port = xatos(t + 1);
+	t--;
+	if (*t == ']') {
+	    *t = '\0';
+	    host = token+1;
+	}
     } else {
 	/* port */
 	port = xatos(token);
+	portstr = token;
     }
     if (port == 0)
 	self_destruct();
-    s->s.sin_port = htons(port);
-    if (NULL == host)
-	s->s.sin_addr = any_addr;
-    else if (1 == safe_inet_addr(host, &s->s.sin_addr))
-	(void) 0;
-    else if ((hp = gethostbyname(host))) {
-	/* dont use ipcache */
-	s->s.sin_addr = inaddrFromHostent(hp);
-	s->defaultsite = xstrdup(host);
-    } else
-	self_destruct();
+
+    memset(&hints, 0, sizeof(hints));
+    if (!host) {
+	hints.ai_family = PF_UNSPEC;
+	hints.ai_socktype = SOCK_STREAM;
+	hints.ai_flags = AI_PASSIVE;
+    }
+    error = getaddrinfo(host, portstr, &hints, &res0);
+    if (error)
+	self_destruct();
+    sn1 = s;
+    sn2 = s;
+    for (res = res0; res; res = res->ai_next) {
+	if ((res->ai_family == AF_INET) ||(res->ai_family == AF_INET6)) {
+	    if (!sn2) {
+		sn2 = cbdataAlloc(http_port_list);
+		sn1->next = sn2;
+		sn1 = sn2;
+	    }
+	    xmemcpy(&sn2->s, res->ai_addr, SOCKLEN(res->ai_addr));
+	    if (res->ai_family == AF_INET6)
+		((struct sockaddr_in6 *)&sn2->s)->sin6_port = htons(port);
+	    else 
+		((struct sockaddr_in *)&sn2->s)->sin_port = htons(port);
+	    if (host)
+		sn2->defaultsite = xstrdup(host);
+	    sn2 = sn2->next;
+	}
+    }
+    freeaddrinfo(res0);
+
 }
 
 static void
@@ -2732,7 +2791,9 @@
 	s->vhost = 1;
 	s->accel = 1;
     } else if (strcmp(token, "vport") == 0) {
-	s->vport = ntohs(s->s.sin_port);
+	s->vport = (s->s.ss_family == AF_INET6) ? 
+		ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
+		ntohs(((struct sockaddr_in *)&s->s)->sin_port);
 	s->accel = 1;
     } else if (strncmp(token, "vport=", 6) == 0) {
 	s->vport = xatos(token + 6);
@@ -2811,8 +2872,10 @@
 {
     storeAppendPrintf(e, "%s %s:%d",
 	n,
-	inet_ntoa(s->s.sin_addr),
-	ntohs(s->s.sin_port));
+	sockaddr_ntoa(&s->s),
+	s->s.ss_family == AF_INET6 ? 
+	ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
+	ntohs(((struct sockaddr_in *)&s->s)->sin_port) );
     if (s->transparent)
 	storeAppendPrintf(e, " transparent");
     if (s->accel)
@@ -2821,7 +2884,7 @@
 	storeAppendPrintf(e, " defaultsite=%s", s->defaultsite);
     if (s->vhost)
 	storeAppendPrintf(e, " vhost");
-    if (s->vport == ntohs(s->s.sin_port))
+    if (s->vport == ntohs(((struct sockaddr_in *)&s->s)->sin_port))
 	storeAppendPrintf(e, " vport");
     else if (s->vport)
 	storeAppendPrintf(e, " vport=%d", s->vport);
diff -r -u squid-2.6.STABLE13/src/cf.data.pre new-STABLE13/src/cf.data.pre
--- squid-2.6.STABLE13/src/cf.data.pre	Wed Apr 25 06:30:03 2007
+++ new-STABLE13/src/cf.data.pre	Sun May 13 00:59:36 2007
@@ -380,15 +380,26 @@
 	By default, Squid doesn't listen on any multicast groups.
 DOC_END
 
+NAME: udp_incoming_address6
+TYPE: address*
+LOC:Config.Addrs.udp6_incoming
+DEFAULT: ::
+DOC_NONE
+
+NAME: udp_outgoing_address6
+TYPE: address*
+LOC:Config.Addrs.udp6_outgoing
+DEFAULT: ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff
+DOC_NONE
 
 NAME: udp_incoming_address
-TYPE: address
+TYPE: address*
 LOC:Config.Addrs.udp_incoming
 DEFAULT: 0.0.0.0
 DOC_NONE
 
 NAME: udp_outgoing_address
-TYPE: address
+TYPE: address*
 LOC: Config.Addrs.udp_outgoing
 DEFAULT: 255.255.255.255
 DOC_START
@@ -412,6 +423,7 @@
 	have the same value since they both use port 3130.
 DOC_END
 
+
 COMMENT_START
  OPTIONS WHICH AFFECT THE NEIGHBOR SELECTION ALGORITHM
  -----------------------------------------------------------------------------
@@ -1477,8 +1489,20 @@
 DOC_END
 
 
+NAME: client_masklen
+TYPE: int
+LOC: Config.Addrs.client_masklen
+DEFAULT: 32
+DOC_NONE
+
+NAME: client6_masklen
+TYPE: int
+LOC: Config.Addrs.client6_masklen
+DEFAULT: 128
+DOC_NONE
+
 NAME: client_netmask
-TYPE: address
+TYPE: address*
 LOC: Config.Addrs.client_netmask
 DEFAULT: 255.255.255.255
 DOC_START
@@ -2828,10 +2852,10 @@
 
 NOCOMMENT_START
 #Recommended minimum configuration:
-acl all src 0.0.0.0/0.0.0.0
+acl all src 0.0.0.0/0 ::/0
 acl manager proto cache_object
-acl localhost src 127.0.0.1/255.255.255.255
-acl to_localhost dst 127.0.0.0/8
+acl localhost src 127.0.0.1/32 ::1/128
+acl to_localhost dst 127.0.0.0/8 ::/126
 acl SSL_ports port 443
 acl Safe_ports port 80		# http
 acl Safe_ports port 21		# ftp
@@ -3162,8 +3186,8 @@
 	Example where normal_service_net uses the TOS value 0x00
 	and normal_service_net uses 0x20
 
-	acl normal_service_net src 10.0.0.0/255.255.255.0
-	acl good_service_net src 10.0.1.0/255.255.255.0
+	acl normal_service_net src 10.0.0.0/24
+	acl good_service_net src 10.0.1.0/24
 	tcp_outgoing_tos 0x00 normal_service_net 0x00
 	tcp_outgoing_tos 0x20 good_service_net
 
@@ -3201,8 +3225,8 @@
 	source address 10.1.0.2 and the rest will be forwarded with
 	source address 10.1.0.3.
 
-	acl normal_service_net src 10.0.0.0/255.255.255.0
-	acl good_service_net src 10.0.1.0/255.255.255.0
+	acl normal_service_net src 10.0.0.0/24
+	acl good_service_net src 10.0.1.0/24
 	tcp_outgoing_address 10.0.0.1 normal_service_net
 	tcp_outgoing_address 10.0.0.2 good_service_net
 	tcp_outgoing_address 10.0.0.3
@@ -3986,7 +4010,7 @@
 	requests, except those in your local domain use something like:
 
 		acl local-servers dstdomain .foo.net
-		acl all src 0.0.0.0/0.0.0.0
+		acl all src 0.0.0.0/0 ::/0
 		never_direct deny local-servers
 		never_direct allow all
 
@@ -4191,13 +4215,13 @@
 DOC_END
 
 NAME: snmp_incoming_address
-TYPE: address
+TYPE: address*
 LOC: Config.Addrs.snmp_incoming
 DEFAULT: 0.0.0.0
 IFDEF: SQUID_SNMP
 DOC_NONE
 NAME: snmp_outgoing_address
-TYPE: address
+TYPE: address*
 LOC: Config.Addrs.snmp_outgoing
 DEFAULT: 255.255.255.255
 IFDEF: SQUID_SNMP
@@ -4232,13 +4256,13 @@
 DOC_END
 
 NAME: wccp_router
-TYPE: address
+TYPE: address*
 LOC: Config.Wccp.router
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCP
 DOC_NONE
 NAME: wccp2_router
-TYPE: sockaddr_in_list
+TYPE: sockaddr_storage_list
 LOC: Config.Wccp2.router
 DEFAULT: none
 IFDEF: USE_WCCPv2
@@ -4408,13 +4432,13 @@
 DOC_END
 
 NAME: wccp_address
-TYPE: address
+TYPE: address*
 LOC: Config.Wccp.address
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCP
 DOC_NONE
 NAME: wccp2_address
-TYPE: address
+TYPE: address*
 LOC: Config.Wccp2.address
 DEFAULT: 0.0.0.0
 IFDEF: USE_WCCPv2
@@ -4688,7 +4712,7 @@
 
 NAME: mcast_miss_addr
 IFDEF: MULTICAST_MISS_STREAM
-TYPE: address
+TYPE: address*
 LOC: Config.mcast_miss.addr
 DEFAULT: 255.255.255.255
 DOC_START
diff -r -u squid-2.6.STABLE13/src/cf_gen.c new-STABLE13/src/cf_gen.c
--- squid-2.6.STABLE13/src/cf_gen.c	Tue May 23 03:55:23 2006
+++ new-STABLE13/src/cf_gen.c	Sun May 13 00:59:36 2007
@@ -85,6 +85,7 @@
     Line *doc;
     Line *nocomment;
     int array_flag;
+    int ptr_flag;
     struct Entry *next;
 } Entry;
 
@@ -215,6 +216,12 @@
 		    curr->array_flag = 1;
 		    *(ptr + strlen(ptr) - 2) = '\0';
 		}
+		/* hack to support pointers to struct */
+		curr->ptr_flag = 0;
+		if (0 == strcmp(ptr + strlen(ptr) - 1, "*")) {
+		    curr->ptr_flag = 1;
+		    *(ptr + strlen(ptr) - 1) = '\0';
+		}
 		curr->type = xstrdup(ptr);
 	    } else if (!strncmp(buff, "IFDEF:", 6)) {
 		if ((ptr = strtok(buff + 6, WS)) == NULL) {
@@ -521,9 +528,10 @@
 	    continue;
 	if (entry->ifdef)
 	    fprintf(fp, "#if %s\n", entry->ifdef);
-	fprintf(fp, "\tdump_%s(entry, \"%s\", %s);\n",
+	fprintf(fp, "\tdump_%s(entry, \"%s\", %s%s);\n",
 	    entry->type,
 	    entry->name,
+	    entry->ptr_flag ? "&" : "",
 	    entry->loc);
 	if (entry->ifdef)
 	    fprintf(fp, "#endif\n");
diff -r -u squid-2.6.STABLE13/src/client_db.c new-STABLE13/src/client_db.c
--- squid-2.6.STABLE13/src/client_db.c	Mon Oct 24 00:20:54 2005
+++ new-STABLE13/src/client_db.c	Sun May 13 00:59:36 2007
@@ -36,7 +36,7 @@
 #include "squid.h"
 
 static hash_table *client_table = NULL;
-static ClientInfo *clientdbAdd(struct in_addr addr);
+static ClientInfo *clientdbAdd(struct sockaddr *addr);
 static FREE clientdbFreeItem;
 static void clientdbStartGC(void);
 static void clientdbScheduledGC(void *);
@@ -49,12 +49,14 @@
 #define CLIENT_DB_HASH_SIZE 467
 
 static ClientInfo *
-clientdbAdd(struct in_addr addr)
+clientdbAdd(struct sockaddr *addr)
 {
     ClientInfo *c;
+    char host[100];
+    getnameinfo(addr, SOCKLEN(addr), host, 100, NULL, 0, NI_NUMERICHOST);
     c = memAllocate(MEM_CLIENT_INFO);
-    c->hash.key = xstrdup(inet_ntoa(addr));
-    c->addr = addr;
+    c->hash.key = xstrdup(host);
+    xmemcpy(&c->addr, addr, SOCKLEN(addr));
     hash_join(client_table, &c->hash);
     statCounter.client_http.clients++;
     if ((statCounter.client_http.clients > max_clients) && !cleanup_running && cleanup_scheduled < 2) {
@@ -77,13 +79,13 @@
 }
 
 void
-clientdbUpdate(struct in_addr addr, log_type ltype, protocol_t p, squid_off_t size)
+clientdbUpdate(struct sockaddr *addr, log_type ltype, protocol_t p, squid_off_t size)
 {
-    char *key;
     ClientInfo *c;
+    char key[100];
     if (!Config.onoff.client_db)
 	return;
-    key = inet_ntoa(addr);
+    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	c = clientdbAdd(addr);
@@ -113,13 +115,13 @@
  * -1.  To get the current value, simply call with delta = 0.
  */
 int
-clientdbEstablished(struct in_addr addr, int delta)
+clientdbEstablished(struct sockaddr *addr, int delta)
 {
-    char *key;
+    char key[100];
     ClientInfo *c;
     if (!Config.onoff.client_db)
 	return 0;
-    key = inet_ntoa(addr);
+    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	c = clientdbAdd(addr);
@@ -131,16 +133,16 @@
 
 #define CUTOFF_SECONDS 3600
 int
-clientdbCutoffDenied(struct in_addr addr)
+clientdbCutoffDenied(struct sockaddr *addr)
 {
-    char *key;
+    char key[100];
     int NR;
     int ND;
     double p;
     ClientInfo *c;
     if (!Config.onoff.client_db)
 	return 0;
-    key = inet_ntoa(addr);
+    getnameinfo(addr, SOCKLEN(addr), key, 100, NULL, 0, NI_NUMERICHOST);
     c = (ClientInfo *) hash_lookup(client_table, key);
     if (c == NULL)
 	return 0;
@@ -184,7 +186,7 @@
     hash_first(client_table);
     while ((c = (ClientInfo *) hash_next(client_table))) {
 	storeAppendPrintf(sentry, "Address: %s\n", hashKeyStr(&c->hash));
-	storeAppendPrintf(sentry, "Name: %s\n", fqdnFromAddr(c->addr));
+	storeAppendPrintf(sentry, "Name: %s\n", fqdnFromAddr(&c->addr));
 	storeAppendPrintf(sentry, "Currently established connections: %d\n",
 	    c->n_established);
 	storeAppendPrintf(sentry, "    ICP Requests %d\n",
@@ -299,6 +301,7 @@
 }
 
 #if SQUID_SNMP
+/* XXX husni */
 struct in_addr *
 client_entry(struct in_addr *current)
 {
@@ -347,7 +350,7 @@
     switch (Var->name[LEN_SQ_NET + 2]) {
     case MESH_CTBL_ADDR:
 	Answer = snmp_var_new_integer(Var->name, Var->name_length,
-	    (snint) c->addr.s_addr,
+	    (snint) 0 /* c->addr.s_addr */,
 	    SMI_IPADDRESS);
 	break;
     case MESH_CTBL_HTBYTES:
